<template>
  <div
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class="">
      <h1>Job Seeker
        <!--<span v-if="!loading" class="lbl-verify">-->
        <!--<label v-if="detail.isVerified" class="lbl lbl-success">Verified</label>-->
        <!--<label v-else class="lbl label-default">Unverified</label>-->
        <!--</span>-->
      </h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
      <div class="page-status">

        <el-breadcrumb separator="/">
          <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>

          <el-breadcrumb-item :to="{ path: '/job-seekers' }">Job Seekers</el-breadcrumb-item>

          <el-breadcrumb-item :to="{ path: '/job-seekers/' + $route.params.id }">{{employerName.length < 50 ? employerName : employerName.substring(0,50)+'...'}}</el-breadcrumb-item>

          <el-breadcrumb-item>Edit</el-breadcrumb-item>
          <!--<div v-if="detail.status" class="verified-item">-->
          <!--<span class="lbl lbl-info"> {{$helper.replaceUnderscore(detail.status)}}</span>-->
          <!--</div>-->

        </el-breadcrumb>
        <div
          v-if="!loading"
          class="content-status verified-item"
        >
          <div v-if="status">
            <div
              v-if="status == 'verified'"
              class="content-status verified-item"
            >
              <span class="lbl lbl-success"> {{$helper.replaceUnderscore(status)}}</span>
            </div>
            <div
              v-else-if="status == 'profile_completed'"
              class="content-status verified-item"
            >
              <span class="lbl lbl-info"> {{$helper.replaceUnderscore(status)}}</span>
            </div>
            <div
              v-else
              class="content-status verified-item"
            >
              <span class="lbl label-default"> {{$helper.replaceUnderscore(status)}}</span>
            </div>
          </div>
          <!-- <span
            v-else
            class="lbl label-default"
          >Unverified</span> -->
        </div>
      </div>
    </div>
    <br />
    <el-card
      v-if="isContentFound"
      v-loading="loading"
    >
      <not-found></not-found>
    </el-card>
    <div v-else>
      <el-card
        class="box-card"
        v-loading="loading"
      >
        <div
          class="card-inner"
          v-if="detail"
        >
          <div class="line">
            <div class="">
              <el-row :gutter="5">
                <el-col
                  :xs="24"
                  :sm="12"
                  :md="4"
                >
                  <el-upload
                    :auto-upload="false"
                    class="avatar-uploader companyCover"
                    action="https://jsonplaceholder.typicode.com/posts/"
                    :show-file-list="false"
                    drag
                    :on-change="onChangeIconHandle"
                  >

                    <div
                      v-if="detail.cover"
                      style="height: 100%; width: 100%; display: flex"
                    >
                      <img
                        :src="detail.cover? detail.cover : $store.state.imgHolder"
                        class="avatar"
                      >
                    </div>
                    <i
                      v-else
                      class="el-icon-plus avatar-uploader-icon"
                    ></i>
                  </el-upload>

                </el-col>
              </el-row>

            </div>
          </div>

          <div
            class="form-box"
            style="margin-top: 20px"
          >
            <el-form
              :model="detail"
              :rules="rules"
              ref="detail"
            >
              <el-row :gutter="30">
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Full Name"
                    prop="full_name"
                  >
                    <el-input v-model="detail.full_name" />
                  </el-form-item>
                </el-col>
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Address"
                    prop="address"
                  >
                    <el-input
                      type="text"
                      v-model.lazy="detail.address"
                      @focus="openDialog"
                    />
                  </el-form-item>
                </el-col>
              </el-row>
              <el-row :gutter="30">
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Experience Years"
                    prop="exp_years"
                  > <br>
                    <el-input-number
                      :min="0"
                      :rows="10"
                      v-model="detail.exp_years"
                      label="Experience years"
                    />
                  </el-form-item>
                </el-col>
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Postal Code"
                    prop="postal_code"
                  > <br>
                    <el-input-number
                      v-model="detail.postal_code"
                      :min="0"
                    ></el-input-number>
                  </el-form-item>
                </el-col>
              </el-row>

              <!-- Start Gender & Exp Year  -->
              <el-row :gutter="30">
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Gender"
                    prop="gender"
                  > <br>
                    <el-radio
                      v-model="detail.gender"
                      label="male"
                    >Male</el-radio>
                    <el-radio
                      v-model="detail.gender"
                      label="female"
                    >Female</el-radio>
                  </el-form-item>
                </el-col>
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Birth date"
                    prop="birth_date"
                  > <br>
                    <el-date-picker
                      value-format="yyyy-MM-dd"
                      v-model="detail.birth_date"
                      type="date"
                      placeholder="Pick your birth day"
                    >
                    </el-date-picker>
                  </el-form-item>
                </el-col>
              </el-row>
              <!-- End Gender & Exp Year  -->

              <!-- Start description here -->
              <el-row :gutter="30">

                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Interest categories"
                    prop="interest_category_selected"
                  > <br>
                    <el-select
                      class="select-category"
                      size="large"
                      multiple
                      value-key="id"
                      v-model="detail.interest_category_selected"
                      placeholder="Select"
                    >
                      <el-option
                        width="400"
                        v-for="item in detail.categoryOptions"
                        :key="item.id"
                        :label="item.name"
                        :value="item"
                      >
                      </el-option>
                    </el-select>

                  </el-form-item>
                </el-col>
              </el-row>

              <div>
                <!-- <div  class="btn-left" >
                                    <el-button @click="updateStatus(true)"
                                               :disabled="isDisabledVerify"
                                               v-if="!detail.isVerified"
                                               class="txt-verify verified"
                                               type="success" >
                                        Verify company
                                    </el-button>
                                    <el-button @click="updateStatus(false)"
                                               :disabled="isDisabledVerify"
                                               v-else class="txt-verify unverified"
                                               type="danger" >
                                        Remove verification
                                    </el-button>
                                </div> -->
                <div class="btn-right mv-20">
                  <el-button
                    icon="mdi mdi-content-save-outline"
                    type="primary"
                    @click="save"
                  > Save changes</el-button>
                </div>

              </div>

            </el-form>
          </div>
        </div>
      </el-card>
      <g-maps
        :dialogvisible.sync="mapvisible"
        :latitude.sync="detail.latitude"
        :longitude.sync="detail.longitude"
        :address.sync="detail.address"
        :detail.sync="detail"
        :postal_code.sync="detail.postal_code"
        :location.sync="location"
        rerefreshList
      >
      </g-maps>
      <!-- <view-image
                    :dialogvisible.sync="dialogvisible"
                    :imageUrl.sync="imageUrl">
            </view-image> -->
    </div>

  </div>
</template>

<script>
export default {

}
</script>
<script>
import { seeker as seekerAPI, media as mediaAPI, category as categoryAPI } from '~/services/apis/index'
import GMaps from './MapPicker.vue'
import NotFound from '../ContentNotFound'
export default {
  name: 'SeekerEdit',
  components: {
    GMaps,
    NotFound,
  },
  data () {
    return {
      detail: {
        id: '',
        full_name: '',
        email: '',
        created_at: "",
        exp_years: '',
        interest_category_ids: [],
        interest_category_selected: [],
        categoryOptions: [],
        birth_date: '',
        gender: '',
        verified_at: "",
        icon_url: "",
        address: "",
        postal_code: '',
        latitude: "",
        longitude: "",
        phone_number: "",
        phone_number_verified_at: "",
        location: {
          lat: 0,
          lng: 0
        },
        cover: "",
        employerName: "",
        imageName: "",
        updateIcon: false,
        file: null,
      },

      loading: true,
      listImage: [
        {
          src: "",
          file: null
        },
      ],
      imageIndex: "",
      file: '',
      mapvisible: false,
      dialogvisible: false,
      imageUrl: null,
      address: "",

      backToEmployers: false,
      employerName: "",
      backID: "",
      isContentFound: false,
      isDisabledVerify: false,
      isDisabledSave: false,
      location: {},
      rules: {
        address: [
          { required: true, message: 'Please input address', trigger: 'change' },],
        postal_code: [
          { type: 'number', message: 'Postal code must be a number', trigger: 'blur' }
        ],
        exp_years: [
          { required: true, message: 'Please input experience year(s)', trigger: 'blur' },
        ],
        full_name: [
          { required: true, message: 'Please input  name', trigger: 'blur' },
          { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
        ],
        interest_category_selected: [
          { required: true, message: 'Please choose category', trigger: 'change' },
        ],
        birth_date: [
          { required: true, message: 'Please input birth date', trigger: 'blur' },
        ],
        gender: [
          { required: true, message: 'Please choose gender', trigger: 'blur' },
        ],


      },

    }
  },
  methods: {

    onChangeIconHandle (file, fileList) {
      if (!file) return;

      this.imageName = file.name;
      this.detail.cover = URL.createObjectURL(file.raw);
      this.file = file.raw;
      this.updateIcon = true;
      this.uploadImage(this.file);
    },
    /* Upload image */
    uploadImage (data) {
      this.loading = true;
      if (data) {
        mediaAPI.upload(data).then(res => {
          if (res.data.success) {
            let image = {
              path: res.data.data.path
            }
            const data = {
              user: {
                avatar_path: res.data.data.path,
              },
            };
            seekerAPI.updateSeeker(this.$route.params.id, data)
              .then((res) => {
                this.$notify({
                  title: "Success",
                  message: "Update image successfully!",
                  type: "success"
                });
                this.loading = false;
              })
              .catch((err) => {
                this.$notify({
                  title: "Error",
                  message: "Update image failed!",
                  type: "error"
                });
                this.loading = false;
              })
          }
        });
      }
    },
    getDetail () {
      if (!this.$route || !this.$route.params.id) return;
      seekerAPI.getSeeker(this.$route.params.id)
        .then((res) => {
          if (res.data.success) {
            console.log('res.data.data :', res.data.data);
            this.initDetail(res.data.data);
          }
          this.isContentFound = false;
          this.loading = false;
        })
        .catch((err) => {
          this.isContentFound = true;
          this.loading = false;
        })
    },

    initDetail (data) {
      if (!data) return;

      this.detail.id = data.id;
      this.detail.exp_years = data.exp_years;
      this.detail.gender = data.user.gender;
      this.detail.birth_date = data.user.birth_date;
      this.detail.full_name = this.employerName = data.user.full_name;
      this.detail.email = data.user.email;
      this.status = data.status;
      this.detail.phone_number = data.user.phone_number;
      this.detail.isVerified = data.user.phone_number_verified_at ? true : false;

      if (data.address) {
        this.address = data.address.street;
        this.detail.address = data.address.street;
        this.detail.latitude = data.address.latitude;
        this.detail.longitude = data.address.longitude;
        this.detail.phone_number = data.address.phone_number;
        this.detail.postal_code = Number(data.address.postal_code)
        this.detail.phone_number_verified_at = data.address.phone_number_verified_at;

        this.detail.location = {
          lat: Number(this.detail.latitude),
          lng: Number(this.detail.longitude)
        }
      }
      if (data.interests) {
        this.detail.interest_category_selected = [...data.interests];
      }
      if (data.user && data.user.avatar_url)
        this.detail.cover = data.user.avatar_url;

      this.listImage[0].src = this.detail.cover;
    },
    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page)
      //this.$router.push({query: {page: page}})
      this.getListPost();
    },
    formatSalary (from, to) {
      if (!from && !to) {
        return ""
      }
      return "from " + from + " to " + to;
    },

    openDialog () {
      this.mapvisible = true
    },


    /* Save update */
    save () {
      this.loading = true;
      console.log('this.$refs :', this.$refs['detail']);
      this.$refs['detail'].validate((valid) => {
        console.log('valid :', valid);
        if (valid) {
          this.submit();
        } else {
          this.loading = false;
          return false;
        }
      });

    },
    /* Submit form */
    submit () {
      if (this.file) {
        this.loading = true
        mediaAPI.upload(this.file)
          .then(res => {
            if (res.data.success) {
              let location = this.location
              let categoriesID = this.detail.interest_category_selected.map(e => {
                return e.id
              })
              let data = {
                user: {
                  avatar_path: res.data.data.path,
                  full_name: this.detail.full_name,
                  gender: this.detail.gender,
                  birth_date: this.detail.birth_date,
                },
                address: { ...location, postal_code: this.detail.postal_code },
                exp_years: this.detail.exp_years,
                interest_category_ids: categoriesID
              };
              seekerAPI.updateSeeker(this.$route.params.id, data)
                .then((res) => {
                  this.$notify({
                    title: "Success",
                    message: "Update successfully!",
                    type: "success"
                  });
                  this.loading = false;
                  this.$router.push({ name: 'job_seekers_detail', params: this.$route.params.id });
                })
                .catch((err) => {
                  this.$notify({
                    title: "Error",
                    message: "Update failed!",
                    type: "error"
                  });
                  this.loading = false;
                })
            }

          }).catch(err => {
            this.$notify({
              title: "Error",
              message: "Update failed!",
              type: "error"
            });
            this.loading = false;
          })
      } else {
        let categoriesID = this.detail.interest_category_selected.map(e => {
          return e.id
        })
        let location = this.location
        let data = {
          user: {
            full_name: this.detail.full_name,
            gender: this.detail.gender,
            birth_date: this.detail.birth_date,
          },
          address: { ...location, postal_code: this.detail.postal_code },
          exp_years: this.detail.exp_years,
          interest_category_ids: categoriesID
        };
        seekerAPI.updateSeeker(this.$route.params.id, data)
          .then((res) => {
            this.$notify({
              title: "Success",
              message: "Update successfully!",
              type: "success"
            });
            this.loading = false;
            this.$router.push({ name: 'job_seekers_detail', params: this.$route.params.id });
          })
          .catch((err) => {
            this.$notify({
              title: "Error",
              message: "Update failed!",
              type: "error"
            });
            this.loading = false;
          })
      }


    },
    onRemoveImg (e) {
      e.preventDefault();
      e.stopPropagation();
      this.removeImg();
    },
    removeImg () {
      this.imageName = "";
      this.file = null;
      this.updateIcon = true;
      this.detail.cover = "";
    },
    // getInterests () {
    //   seekerAPI.getInterests(this.$route.params.id).then(res => {
    //     if (res.data.success) {

    //       this.detail.interest_category_selected = [...res.data.data];
    //       console.log('this.detail.i :', this.detail.interest_category_selected);

    //     }
    //   })
    //     .catch(err => {
    //       console.log('Get interest: ', err)
    //     })
    // },
    getAllCategories () {
      categoryAPI.getCategories().then(res => {
        this.detail.categoryOptions = [...res.data.data];
      })
        .catch(err => {

        })
    },

  },
  watch: {
    address: function () {
      console.log('address', this.address);
    }
  },
  mounted () {
    this.getDetail();
    // this.getInterests();
    this.getAllCategories();
    // this.getListPost();


  }
}
</script>
<style lang="scss" scope>
.select-category {
  width: 300px;
}
.icon-img-close-employer {
  position: absolute;
  top: 3px;
  right: 5px;
  padding: 3px !important;
}
</style>
